=== debian/changelog ===
mysql-cluster-community (8.0.19-1debian10) buster; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-19.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Tue, 10 Dec 2019 11:48:23 +0100
